#!/usr/bin/env python

import sys
# =============================================================================
def usage():

    print 'Usage: txt2csv.py [input_file] [output_file] [mask_file]'
    print ''
    print 'input_file'
    print ' -> is a flat text datafile where fields have a fixed length'
    print 'output_file'
    print ' -> is a standard csv file'
    print 'mask_file'
    print ' -> is a text file describing how to split the fields, in the form'
    print '    FIELD_NAME;LENGTH (one for each row). Field name is optional.'
    print ''
    print 'You need to have python installed to run this program (but if you are'
    print 'reading this text it means it is already installed on your system)'
    print ''
    print 'Bugs and suggestion to: antonello a.t. lobianco . org'
    print 'This program is free software, released under GNU GPL licence v.2'

    sys.exit(1)

# =============================================================================
def main():


    if len(sys.argv) != 4 or sys.argv[1] == '-h' or sys.argv[1] == '-help':
       usage()

    inputfile_filename  = sys.argv[1]
    outputfile_filename = sys.argv[2]
    maskfile_filename   = sys.argv[3]
    separator= ';'

    print ''
    print 'txt2csv: a program to convert flat files to csv files'
    print 'Relased under GNU GPL licence. Copyright Antonello Lobianco, 2006'
    print 'Pleas consult the README file for usage.'
    print ''
    print 'Using maskfile:',maskfile_filename
    print 'Using inputfile:',inputfile_filename
    print 'Using outputfile:',outputfile_filename
    maskNames=[]
    maskValues=[]
    maskMin=[]
    maskMax=[]
    maskCum=0;
    maskfile = open(maskfile_filename,'r')
    masks=maskfile.readlines();
    maskfile.close()
    maskLength = len (masks)
    print 'maskLength:', maskLength
    #print masks
    for mask in masks:
        maskStripped = mask.strip('\n')
        tempMask = maskStripped.split(';')
        maskNames.append(tempMask[0])
        value =int(tempMask[1])
        maskValues.append(value)
        maskMin.append(maskCum)
        maskCum += value
        maskMax.append(maskCum)



    print maskMin
    print maskMax

    inputfile = open(inputfile_filename,'r')
    outputfile = open(outputfile_filename,'w')
    test=1;
    while test:
        inputRow = inputfile.readline()
        if inputRow == '':
            break
        inputRowStripped=inputRow.strip('\n') 

        tempFields=[]
        outputRow='';
        lista = range(maskLength)
        for i in lista:
            tempFields.append(inputRowStripped[maskMin[i]:maskMax[i]])


        for i in lista:
            outputRowField='"'+tempFields[i]+'"'+separator
            outputRow+=outputRowField
        outputRow+='\n'
        outputfile.write(outputRow)

    inputfile.close() 
    outputfile.close()
    print 'done!'

main()
